/**
 * Module that registers the notification box and handles messages
 */
var Notifications = {
	
	more: false,
	font_size: 100,
	
	init: function(options) {
		this.options = $.extend(
			this.options,
			options
		);
		
		// Create the notifications box
		// mobile
		elem = $('<div>').attr({
			id: 'notifications',
			className: 'notifications'
		});
		
		$('<div>')
			.text('...')
			.css('margin', '5px')
			.css('padding', '0 100px 100px 10px')
			.css('position', 'absolute')
			.css('top', '0')
			.appendTo(elem)
			.click(function() {
				if (Notifications.more == false) {
					$('#notifications').animate({bottom:0});
					Notifications.more = true;
				}
				else {
					$('#notifications').animate({bottom:"-300px"});
					Notifications.more = false;
				}
			});
			
		var d = $('<div>')
			.css('position', 'absolute')
			.css('bottom', '0')
			.css('width', '100%')
			.css('padding', '10px 0')
			.css('background-color', 'rgb(39, 40, 35)');
		
		var b = $('<div>').text('Aa+')
			.css('border', '1px white solid')
			.css('display', 'inline-block')
			.css('bottom', '0')
			.css('width', '30%')
			.click(function() {
				Notifications.font_size += 10;
				$('body').css('font-size', Notifications.font_size.toString()+'%');
				window.localStorage.setItem("font-size", Notifications.font_size.toString());
			});
			
		b.appendTo(d);
		
		b = $('<div>').text('Aa-')
			.css('border', '1px white solid')
			.css('display', 'inline-block')
			.css('bottom', '0')
			.css('width', '30%')
			.click(function() {
				Notifications.font_size -= 10;
				if (Notifications.font_size < 10) Notifications.font_size = 10;
				$('body').css('font-size', Notifications.font_size.toString()+'%');
				window.localStorage.setItem("font-size", Notifications.font_size.toString());
			});
			
		b.appendTo(d);
		
		d.appendTo(elem);
			
		// Create the transparency gradient
		$('<div>').attr('id', 'notifyGradient').appendTo(elem);
		
		elem.appendTo('div#wrapper');
	},
	
	options: {}, // Nothing for now
	
	elem: null,
	
	notifyQueue: {},
	
	// Allow notification to the player
	notify: function(module, text, noQueue) {
		if(typeof text == 'undefined') return;
		if(text.slice(-1) != ".") text += ".";
		if(module != null && Engine.activeModule != module) {
			if(!noQueue) {
				if(typeof this.notifyQueue[module] == 'undefined') {
					this.notifyQueue[module] = new Array();
				}
				this.notifyQueue[module].push(text);
			}
		} else {
			Notifications.printMessage(text);
		}
		Engine.saveGame();
	},
	
	clearHidden: function() {
	
		// To fix some memory usage issues, we clear notifications that have been hidden.
		
		// We use position().top here, because we know that the parent will be the same, so the position will be the same.
		var bottom = $('#notifyGradient').position().top + $('#notifyGradient').outerHeight(true);
		
		$('.notification').each(function() {
		
			if($(this).position().top > bottom){
				$(this).remove();
			}
		
		});
		
	},
	
	printMessage: function(t) {
		var text = $('<div>').addClass('notification').css('opacity', '0').text(t).prependTo('div#notifications');
		text.animate({opacity: 1}, 500, 'linear', function() {
			// Do this every time we add a new message, this way we never have a large backlog to iterate through. Keeps things faster.
			Notifications.clearHidden();
		});
	},
	
	printQueue: function(module) {
		if(typeof this.notifyQueue[module] != 'undefined') {
			while(this.notifyQueue[module].length > 0) {
				Notifications.printMessage(this.notifyQueue[module].shift());
			}
		}
	}
};
